;; --------------------------------------------------------------------------------
;;
;; $Id: gnus-autoreply.el,v 1.2 1998/12/15 11:17:06 swa Exp $
;;
;; Stefan Waldherr <swa@cs.cmu.edu>
;;
;; --------------------------------------------------------------------------------
;;
;; Based on stuff from dsg@mitre.org (David S. Goldberg) and 
;; SL Baur <steve@xemacs.org>
;;
;; --------------------------------------------------------------------------------
;;
;; Installation:
;; -------------
;;  Put this file somewhere and load it from your .gnus file with, e.g.
;;  (load-file (expand-file-name "~/bin/emacs/gnus-autoreply.el"))
;; 
;;  Create a bunch of standard replies and put them (with suggestive names)
;;  into, say, ~/Mail/.autoreply. Change gnus-autoreply-dir accordingly.
;;
;; Usage:
;; ------
;;
;;  Reply to a mail. In the *Article* buffer, hit `C-c r'. Choose the file
;;  which you want to insert. Then change it and/or hit `C-c C-c' to send
;;  the mail. Voila.
;;
;; --------------------------------------------------------------------------------
;; 
;; $Log: gnus-autoreply.el,v $
;; Revision 1.2  1998/12/15 11:17:06  swa
;; Used steve's stuff.
;;
;; Revision 1.1  1998/12/15 11:05:16  swa
;; First version.
;;
;; --------------------------------------------------------------------------------

;; where the replies can be found
(setq gnus-autoreply-dir "/home/swa/Mail/.autoreply")

;; prefix it with `reply-' or something. If you want.
(setq gnus-autoreply-file-prefix "")

;; the function that takes care of choosing the file and inserting it
(defun gnus-summary-autoreply ()
  "Automatic reply."
  (interactive)
  ;(message-remove-header "from")
  ;(message-add-header "From: Patch Acknowledgement <steve@xemacs.org>"
  ;"X-Emacs-Patch-Ack: yes")
  (message-goto-body)
  (let ((gnus-autoreply-file 
	 (completing-read "Reply File: "
			  (mapcar 'list
				  (directory-files
				   gnus-autoreply-dir nil
				   (regexp-quote gnus-autoreply-file-prefix)))
			  nil t gnus-autoreply-file-prefix))
	(gnus-autoreplyed-user (save-excursion
			      (set-buffer gnus-article-buffer)
			      (or (message-fetch-field "Reply-To")
				  (message-fetch-field "From")))))
    (if (= (length gnus-autoreply-file) 0)
	(setq gnus-autoreply-file auto-default-reply-file))
    (if (not gnus-autoreplyed-user)
	(error "Error in message structure: no Reply-To or From lines."))
    (insert-file-contents (concat gnus-autoreply-dir "/" gnus-autoreply-file))
    ))

;; define the key
(add-hook 'message-load-hook
          (define-key message-mode-map [(control ?c) ?r] 'gnus-summary-autoreply))
